﻿/*
Copyright 2017 Coin Foundry (coinfoundry.org)
Authors: Oliver Weichhold (oliver@weichhold.com)

Permission is hereby granted, free of charge, to any person obtaining a copy of this software and
associated documentation files (the "Software"), to deal in the Software without restriction,
including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense,
and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so,
subject to the following conditions:

The above copyright notice and this permission notice shall be included in all copies or substantial
portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT
LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
*/

using Newtonsoft.Json;

namespace MiningCore.Blockchain.Monero.DaemonResponses
{
    public class BlockHeader
    {
        public long Difficulty { get; set; }
        public long Depth { get; set; }
        public uint Height { get; set; }
        public string Hash { get; set; }
        public string Nonce { get; set; }
        public ulong Reward { get; set; }
        public ulong Timestamp { get; set; }

        [JsonProperty("major_version")]
        public uint MajorVersion { get; set; }

        [JsonProperty("minor_version")]
        public uint MinorVersion { get; set; }

        [JsonProperty("prev_hash")]
        public string PreviousBlockhash { get; set; }

        [JsonProperty("orphan_status")]
        public bool IsOrphaned { get; set; }
    }

    public class GetBlockHeaderResponse
    {
        [JsonProperty("block_header")]
        public BlockHeader BlockHeader { get; set; }

        public string Status { get; set; }
    }
}
